﻿Type=Activity
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region 

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim myBmp As Bitmap 
	Dim myBmpFile As String

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	'Setup a helper variable to set the number of Columns which we will re-use
	Dim NumCols As Int = 3
	Dim NumRows As Int = 3

	Dim TileWidth As Int 
	Dim TileHeight As Int 

	Dim PicGrid As MSDynamicGridView
	Dim PicAdapter As MSDynamicAdapter
	
	Dim TileMap As Map 
	
	Dim ShowHints As Boolean = False
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Color = Colors.Black 

	Dim btnMore As Button 
	btnMore.Initialize("btnMore")
	Activity.AddView(btnMore,  100%x - 48dip,0dip,48dip,48dip)
	

	If myBmp = Null OR myBmp.IsInitialized=False Then	
		Try
			'try to find last bitmap used
			myBmpFile = File.ReadString(File.DirInternal,"bmpfile")
			myBmp = LoadBitmap(myBmpFile,"")
		Catch
			myBmp = LoadBitmap(File.DirAssets,"save.png")
		End Try
	End If
	Log("Original:" & myBmp.Width & "x" & myBmp.Height)

	
	'Scale bimap and take care of aspect ratio
	Dim scaledWidth As Float = myBmp.Width/100%x
	Dim scaledHeight As Float = myBmp.Height /100%y
	Dim scaleRatio As Float = Max(scaledWidth,scaledHeight)
	'Aspect ratio scale
	Dim myScaledBmp As Bitmap = CreateScaledBitmap(myBmp, myBmp.Width/scaleRatio, myBmp.Height/scaleRatio,False)
	Log("f:" & myScaledBmp.Width & "x" & myScaledBmp.Height)
	myBmp = Null 'Clear reference

	
	Dim ImageWidth  As Int= myScaledBmp.Width 
	Dim ImageHeight As Int = myScaledBmp.Height 

	Dim TileWidth As Int = ImageWidth/NumCols
	Dim TileHeight As Int = ImageHeight/NumRows

	PicGrid.Initialize("PicGrid")
	PicGrid.NumColumns = NumCols
	
	Dim dy As Int 
	If ImageHeight < 100%y Then
		dy = (100%y - ImageHeight)/2
	End If
	Dim dx As Int 
	If ImageWidth < 100%x Then
		dx = (100%x - ImageWidth)/2
	End If
	
	Activity.AddView(PicGrid,dx,dy,ImageWidth,ImageHeight)
	
	PicAdapter.Initialize("DA",NumCols, TileWidth, TileHeight)
	
	TileMap.Initialize 
	For y = 0 To NumRows-1
		For x = 0 To NumCols-1
			Dim ItemTag As String = "Item (" & y & "," & x & ")"
			PicAdapter.Add(ItemTag)
			Dim TiledBmp As Bitmap = CreateBitmapTile(myScaledBmp,(x*TileWidth),(y*TileHeight),TileWidth,TileHeight)
			TileMap.Put(ItemTag, TiledBmp)
		Next
	Next
	Log("Tiled:" & TiledBmp.Width & "x" & TiledBmp.Height)
	

	'Set the Gridview's adapter
	PicGrid.Adapter = PicAdapter.GetAdapter 


	'Randomize
	ShuffleGrid
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	File.WriteString(File.DirInternal,"bmpfile",myBmpFile)
End Sub

'Events
Sub btnMore_Click
	'Too many libraries needed for this functionality so been removed in this cutdown version
	ToastMessageShow("Code removed to limited libraries",False)
End Sub

Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
  Dim jo As JavaObject
  Dim b As Bitmap
  b = jo.InitializeStatic("android.graphics.Bitmap").RunMethod("createScaledBitmap", _
      Array As Object(Original, Width, Height, Filter))
  Return b
End Sub

Sub CreateBitmapTile(Original As Bitmap,x As Int, y As Int,w As Int,h As Int) As Bitmap 
	Dim jo As JavaObject
	Dim b As Bitmap 
	b = jo.InitializeStatic("android.graphics.Bitmap").RunMethod("createBitmap",Array(Original,x,y,w,h))
	Return b
End Sub


'--------------------------------------------------------------------------------
' Dynamic Adapter Events
'--------------------------------------------------------------------------------

' Dynamic Adapter GetLayout
' This event should not connect to the content
' You should only create your content here. 
' Create a Panel, add your views or load a layout and return that panel
Sub DA_GetLayout(Position As Int, ItemID As Long, ItemTag As String) As Panel
	Dim p As Panel 
	p.Initialize("")
	Dim lbl As Label 
	lbl.Initialize("")
	p.AddView(lbl, 1dip,1dip,(TileWidth)-2dip,TileHeight-2dip)
	lbl.Text = "HELLO"
	lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	Return p
End Sub

' Dynamic Adapter GetContent
' This event will map your content into the gridview
' You can use Position/ItemID/ItemTag to get your content (text/images) from your storage (list/maps/db)
' See how lbl.Text is mapping our List GridItems which is a local list with our data, into the label text based on the ItemID
Sub DA_GetContent(Position As Int, ItemID As Long, ItemTag As String, ContentPanel As Panel) As Panel
	Dim lbl As Label = ContentPanel.GetView(0)
	If ShowHints = True Then
		lbl.Text = ItemTag
	Else
		lbl.Text = ""
	End If
	ContentPanel.SetBackgroundImage(TileMap.Get(ItemTag))
	Return ContentPanel
End Sub

'--------------------------------------------------------------------------------
' Dynamic Grid Events
'--------------------------------------------------------------------------------

' Here we use the ItemLongClick event to start the edit mode from this position
' We can also use DynamicGrid.StartEditMode
Sub PicGrid_ItemLongClick(Position As Int)
	PicGrid.StartEditModeFromPosition(Position)
End Sub

Sub PicGrid_ItemClick(Position As Int)
	PicGrid.StartEditMode
End Sub

' Here we use this event to stop the edit mode once the user has dropped the item
' We can aternatively stay in edit mode, until the back button is pressed
Sub PicGrid_ItemDrop
	'PicGrid.stopEditMode 
	'Check for completion
	Dim isMatch As Boolean = True
	For i = 0 To TileMap.Size-1
		Dim TileTag As String = TileMap.GetKeyAt(i)
		If PicAdapter.GetItems.IndexOf(TileTag) = i Then
			
		Else
			isMatch = False
		End If
	Next
	If isMatch = True Then
		PicGrid.stopEditMode 
		ToastMessageShow("Reconstructed!!!",False)
	End If
	
End Sub

Sub ShuffleGrid
	'Randomize
	Dim TotalTiles As Int = (NumCols * NumRows)
	For i = 0 To TotalTiles-1
		Dim Tile1 As Int = Rnd(0,TotalTiles-1)
		Dim Tile2 As Int = Rnd(0,TotalTiles-1)
		PicAdapter.reorderItems(Tile1,Tile2)
	Next
End Sub