﻿Type=Activity
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False

#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim MB As MediaBrowser 
	'Setup a helper variable to set the number of Columns which we will re-use
	Dim NumCols As Int = 3
	Dim NumRows As Int = 4
	
	Dim ItemWidth As Int = 100dip
	Dim ItemHeight As Int = 100dip
	
	Dim GalleryGrid As MSDynamicGridView
	Dim GalleryAdapter As MSDynamicAdapter
	Dim lblGridBack As Label 

	Dim btnPrev,btnNext As Button 

	
	Dim PicSource As clsPicSource 
	Dim PicOffset As Int = 0
	Dim PicLimit As Int = 50
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime = False Then
		If File.Exists(File.DirInternal,"PicOffset") Then
			Dim PO As String = File.ReadString(File.DirInternal,"PicOffset")
			Dim p() As String = Regex.Split(",",PO)
			PicOffset = p(0)
			PicLimit  = p(1)
		End If
	End If

	CreateFakeActionbar

	If Activity.Width > Activity.Height Then
		'Landscape!!!
		NumCols = 6
		NumRows = 4
	End If

	ItemWidth = (100%x - 48dip)/NumCols
	ItemHeight = ItemWidth 'To set the aspect ratio

	PicSource.Initialize ( True, Me, "PicSource")

	GalleryGrid.Initialize("PicGrid")
	GalleryGrid.NumColumns = NumCols
	Activity.AddView(GalleryGrid,16dip,120dip,100%x - (2*16dip),100%y - (3*60dip)-24dip)
	GalleryAdapter.Initialize("DA",NumCols, ItemWidth, ItemHeight)

	'Set the Gridview's adapter
	GalleryGrid.Adapter = GalleryAdapter.GetAdapter 
	
	'Setup a label behind the gridview
	lblGridBack.Initialize("lblGridBack")
	Activity.AddView(lblGridBack, 16dip,120dip,100%x - (2*16dip),100%y - (3*60dip)-24dip)
	lblGridBack.Text = "Nothing to say"
	lblGridBack.TextSize = 20
	lblGridBack.TextColor = Colors.DarkGray
	lblGridBack.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL 

	'Button bar at the bottom
	btnPrev.Initialize("btnPrev")
	btnNext.Initialize("btnNext")
	Activity.AddView(btnPrev,0dip,100%y-60dip,50%x,60dip)
	Activity.AddView(btnNext,50%x,100%y-60dip,50%x,60dip)

	btnPrev.Text = "LOAD NEWER"
	btnNext.Text = "LOAD OLDER"

	Dim sld As StateListDrawable 
	sld.Initialize
	Dim C As ColorDrawable : C.Initialize(Colors.rgb(21,101,192),0)
	sld.AddState(sld.State_Pressed, C)
	C.Initialize(Colors.lightGray,0)
	sld.AddCatchAllState(C)
	btnPrev.Background = GenerateButtonBackgrounds
	btnNext.Background = GenerateButtonBackgrounds
	SetColorStateList(btnPrev, Colors.White, Colors.Black, Colors.Gray)
	SetColorStateList(btnNext, Colors.White, Colors.Black, Colors.Gray)

	CallSubDelayed(Me,"Load_Images")
	

End Sub

#Region UI Creation
'--------------------------------------------------------------------------------
' UI Creation
'--------------------------------------------------------------------------------


Sub CreateFakeActionbar
	Dim AB As Panel 
	AB.Initialize("AB")
	AB.Color = Colors.rgb(21,101,192)
	Activity.AddView(AB,0,0,100%x,56dip)
	Dim lblTitle As Label
	lblTitle.Initialize("lblTitle")
	AB.AddView(lblTitle, 16dip, 0dip, 150dip,56dip)
	lblTitle.Text = "Picture Puzzler"
	lblTitle.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL 
	lblTitle.TextSize = 20
	lblTitle.TextColor = Colors.White 
	'Extend Actionbar
	AB.Height = 112dip
	Dim lblMore As Label
	lblMore.Initialize("lblMore")
	AB.AddView(lblMore, 16dip, 56dip, 100%x - 50dip, 112dip-56dip)
	lblMore.Gravity = Gravity.LEFT+Gravity.CENTER_VERTICAL
	lblMore.Text = "Please select a picture from your phone below to use in the puzzle"
	lblMore.TextColor = Colors.White 
End Sub

Sub GenerateButtonBackgrounds As StateListDrawable 
	Dim sld As StateListDrawable 
	sld.Initialize
	Dim C As ColorDrawable : C.Initialize(Colors.rgb(21,101,192),0)
	sld.AddState(sld.State_Pressed, C)
	C.Initialize(Colors.lightGray,0)
	sld.AddCatchAllState(C)
	Return sld
End Sub

'Pass the Button object and Colors int values to set for each state.
Sub SetColorStateList(Btn As Button,Pressed As Int,Enabled As Int,Disabled As Int)
    Dim States(3,1) As Int
    States(0,0) = 16842919    'Pressed
    States(1,0) = 16842910    'Enabled
    States(2,0) = -16842910 'Disabled

    Dim Color(3) As Int = Array As Int(Pressed,Enabled,Disabled)
    Dim CSL As JavaObject
    CSL.InitializeNewInstance("android.content.res.ColorStateList",Array As Object(States,Color))
    Dim B1 As JavaObject = Btn
    B1.RunMethod("setTextColor",Array As Object(CSL))

End Sub

#End Region

#Region PicSourceHooks

Sub Load_Images
	lblGridBack.Text = "Loading images..."
	PicSource.ReadLocalFilesAsync(PicOffset, PicLimit)
	'PicSource.ReadLocalFiles(PicOffset, PicLimit)
	'CallSubDelayed(Me,"PicSource_LoadComplete")
End Sub

Sub PicSource_LoadComplete
	If PicSource.GetSize = 0 Then
		lblGridBack.Text = "Sorry, no images found :("
	Else
		lblGridBack.Text = ""
	End If
	GalleryAdapter.Clear 
	For i = 0 To PicSource.GetSize-1
		Dim ID As Long = PicSource.GetID(i)
		GalleryAdapter.Add(ID)
	Next
	btnPrev.Enabled = True : btnNext.Enabled = True
	If PicOffset = 0 Then
		btnPrev.Enabled = False
	End If
	If PicSource.GetSize = 0 Then
		btnNext.Enabled = False
	End If
	
	GalleryAdapter.NotifyDataSetChanged 
	GalleryGrid.ScrollTo(0)
	
End Sub

#End Region


Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	File.WriteString(File.DirInternal,"PicOffset",PicOffset & "," & PicLimit)
End Sub


'--------------------------------------------------------------------------------
' Button Events
'--------------------------------------------------------------------------------
Sub btnNext_Click
	PicOffset = PicOffset + PicLimit
	PicSource.ReadLocalFilesAsync(PicOffset, PicLimit)
End Sub

Sub btnPrev_Click
	If PicOffset = 0 Then
		Msgbox("Already at beginning of images","Oops")
		Return
	End If
	PicOffset = PicOffset - PicLimit
	PicSource.ReadLocalFilesAsync(PicOffset, PicLimit)
End Sub


'--------------------------------------------------------------------------------
' Dynamic Adapter Events
'--------------------------------------------------------------------------------

' Dynamic Adapter GetLayout
' This event should not connect to the content
' You should only create your content here. 
' Create a Panel, add your views or load a layout and return that panel
Sub DA_GetLayout(Position As Int, ItemID As Long, ItemTag As String) As Panel
	Dim p As Panel 
	p.Initialize("")
	Dim lbl As Label 
	lbl.Initialize("")
	p.AddView(lbl, 1dip,1dip,(ItemWidth)-2dip,ItemHeight-2dip)
	lbl.Text = ""
	lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	
	Dim iv As ImageView : iv.Initialize("")
	p.AddView(iv,3dip,3dip,ItemWidth -6dip,ItemHeight - 6dip)
	iv.Gravity = Gravity.FILL
	Return p
End Sub

' Dynamic Adapter GetContent
' This event will map your content into the gridview
' You can use Position/ItemID/ItemTag to get your content (text/images) from your storage (list/maps/db)
' See how lbl.Text is mapping our List GridItems which is a local list with our data, into the label text based on the ItemID
Sub DA_GetContent(Position As Int, ItemID As Long, ItemTag As String, ContentPanel As Panel) As Panel
	Dim lbl As Label     = ContentPanel.GetView(0)
	Dim iv0 As ImageView = ContentPanel.GetView(1)
	'lbl.Text = TileList.Get(ItemID)
	'lbl.Text = ItemTag
	If PicSource.GetThumbnail(Position).IsInitialized Then
		iv0.SetBackgroundImage(PicSource.GetThumbnail(Position))
	End If
	'Add some animation<removed>
	'Dim M1 As MSAnimator
	'Dim T1 As MSTechniques
	'M1.with(T1.FadeIn).delay(0).duration(300).PlayOn(ContentPanel)
	Return ContentPanel
End Sub

'-------------------------------------------------------
' Gridview events
'-------------------------------------------------------
Sub PicGrid_ItemClick(Position As Int)
	actPicPuzzle.myBmp = PicSource.GetImage(Position)
	actPicPuzzle.myBmpFile = PicSource.GetImageLocation(Position)
	StartActivity(actPicPuzzle)
End Sub