﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private MB As MediaBrowser 
	Private PicMap As Map
	Private pCacheThumbs As Boolean
	Private mModuleName As Object 
	Private mEventName As String 
	
	Private th As Thread 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CacheThumbnails As Boolean, pModuleName As Object, pEventName As String )
	pCacheThumbs = CacheThumbnails
	mEventName = pEventName
	mModuleName = pModuleName
End Sub

' Gallery management
Sub ReadLocalFiles(Offset As Int,ImageLimit As Int)
	Dim ImageMap As Map 
	MB.Initialize("MB")
	ImageMap = MB.GetMediaImageList(True,  "datetaken COLLATE UNICODE DESC limit " & ImageLimit & " offset " & Offset)
	PicMap.Initialize 
	For i = 0 To (ImageMap.Size/7)-1
		Dim subMap As Map 	: subMap.Initialize 
		subMap.Put("Location",ImageMap.get("Location" & i))
		subMap.Put("Thumbnail","")
		PicMap.Put(ImageMap.get("ID" & i), subMap)
	Next
	'Log(PicMap)
	If pCacheThumbs = True Then
		'Thumbnails
		For i = 0 To PicMap.Size-1
			Dim ID As Long =  PicMap.GetKeyAt(i)
		 	Dim subMap As Map =  PicMap.GetValueAt(i)
			Log(ID & " " & subMap)
			Dim bmpThumb As Bitmap = MB.GetImgThumbnailByID(ID,False)
			'Log("Fetched bmpThumb")
			If bmpThumb.IsInitialized AND bmpThumb <> Null Then
				'Log(bmpThumb)
				subMap.Put("Thumbnail",bmpThumb)
				'Log("Put into map")
			Else
				subMap.Put("Thumbnail",Null)
			End If
		Next
	End If
	Log("End ReadLocalFiles")
End Sub

Sub GetImage(Position As Int) As Bitmap 
	If Position > PicMap.Size Then
		Log("PicSource: Out of bounds")
		Return Null
	End If
	Dim submap As Map = PicMap.GetValueAt(Position)
	Dim Location As String = submap.get("Location")
	Return LoadBitmap("", Location)
End Sub

Sub GetThumbnail(Position As Int) As Bitmap 
	If Position > PicMap.Size Then
		Log("PicSource: Out of bounds")
		Return Null
	End If
	Dim submap As Map = PicMap.GetValueAt(Position)
	If pCacheThumbs = False Then 'Fetch
		Dim ID As Long =  PicMap.GetKeyAt(Position)
		Return MB.GetImgThumbnailByID(ID,False)
	Else
		If  submap.Get("Thumbnail") = Null OR _
			submap.Get("Thumbnail") = "null" OR _
			submap.Get("Thumbnail") = "" _
				Then Return Null
		Log(submap.Get("Thumbnail"))
		Return submap.get("Thumbnail")
	End If
End Sub

Sub GetImageLocation(Position As Int) As String 
	If Position > PicMap.Size Then
		Log("PicSource: Out of bounds")
		Return Null
	End If
	Dim submap As Map = PicMap.GetValueAt(Position)
	Dim Location As String = submap.get("Location")
	Return Location
End Sub


Sub GetID(Position As Int) As Long 
	If Position > PicMap.Size Then
		Log("PicSource: Out of bounds")
		Return 0
	End If
	Dim submap As Map = PicMap.GetValueAt(Position)
	Dim ID As Long =  PicMap.GetKeyAt(Position)
	Return ID	
End Sub

Sub GetSize As Int
	Return PicMap.Size 
End Sub

Sub SaveState
	File.WriteMap(File.DirInternal,"PicSource",PicMap)
End Sub

Sub LoadState 
	PicMap = File.ReadMap(File.DirInternal,"PicSource")
End Sub

Sub ReadLocalFilesAsync(Offset As Int, ImageLimit As Int)
	If th.IsInitialized = True AND th.Running = True Then Return
	th.Initialise("ReadLocalFilesAsync")
	th.Start(Me,"ReadLocalFiles",Array(Offset,ImageLimit))
	
End Sub

Private Sub isFetching As Boolean 
	If th.IsInitialized = False Then Return False
	Return th.Running
End Sub

Private Sub ReadLocalFilesAsync_Ended(endedOK As Boolean, error As String) 'The thread has terminated. If endedOK is False error holds the reason for failure
	Log("Thread ended " & endedOK)
	If endedOK Then
		CallSub(mModuleName,mEventName & "_LoadComplete")
	Else
		Log(error)
	End If
End Sub
